; script pour Direct Connect, logiciel de partage de fichiers
; Version 1.0, 16 Fvrier 2002
; frederic.brugnot@wanadoo.fr

include "default.jsm"
include "hjconst.jsh"
include "hjglobal.jsh"
include "direct connect.jsm"

Globals
	int NoFocusEvent,
	int LitLigneListe

Script ScriptFileName ()
if IsSameScript () then
	SayString ("Version 1.0, 16 Fvrier 2002, frederic.brugnot@wanadoo.fr")
else
	ScriptAndAppNames ("Direct Connect")
endif
EndScript

Function AppFileTopic ()
Run ("\"" + GetJawsSettingsDirectory () + "\\direct connect.txt\"")
EndFunction

Int Function ISOngletUsers (handle hwnd)
return GetWindowTypeCode (hwnd) == WT_TABCONTROL && GetControlID (GetParent (hwnd)) == 10
EndFunction

Int Function IsListeUser (handle hwnd)
return GetWindowTypeCode (hwnd) == WT_LISTVIEW && GetControlID (GetParent (hwnd)) == 10 
EndFunction

Void Function IsEditionSearch (handle hwnd)
return GetWindowTypeCode (hwnd) == WT_EDIT &&  GetControlID (hwnd) == 6
	&& GetControlID (GetParent (hwnd)) == 5
	&& GetWindowTypeCode (GetParent (hwnd)) == WT_BUTTON
EndFunction

Int Function IsOngletTransfers (handle hwnd)
return GetWindowTypeCode (hwnd) == WT_TABCONTROL 
	&& GetControlID (GetParent (hwnd))  == 8
EndFunction

Int Function IsListeTransfers (handle hwnd)
return GetWindowTypeCode (hwnd) == WT_LISTVIEW && GetControlID (GetParent (hwnd)) == 9
EndFunction

Int Function IsListeQueueUser (handle hwnd)
var	string HeaderName

let HeaderName = GetWindowText (GetFirstChild (hwnd), FALSE)
return GetWindowTypeCode (hwnd) == WT_LISTVIEW 
	&& GetControlID (GetParent (hwnd)) == 9
	&& HeaderName == STR_QUEUE_USER
	&& StringLength (HeaderName) == StringLength (STR_QUEUE_USER)
EndFunction

Int Function IsListeQueueFile (handle hwnd)
var	string HeaderName

let HeaderName = GetWindowText (GetFirstChild (hwnd), FALSE)
return GetWindowTypeCode (hwnd) == WT_LISTVIEW 
	&& GetControlID (GetParent (hwnd)) == 9
	&& HeaderName == STR_QUEUE_FILE
	&& StringLength (HeaderName) >= StringLength (STR_QUEUE_FILE)
EndFunction

Int Function IsListeHub (handle hwnd)
return GetWindowTypeCode (hwnd) == WT_LISTVIEW 
	&& GetControlID (GetPriorWindow (hwnd)) == 6
EndFunction

Int Function IsComboSpeed (handle hwnd)
return GetWindowTypeCode (GetParent (hwnd)) == WT_COMBOBOX 
	&& GetControlID (GetParent (GetParent (GetParent (hwnd)))) >= 29
EndFunction

Int Function IsDialogueConnect (handle hwnd)
var	handle h

let h =  GetFirstChild (GetRealWindow (hwnd))
return   GetWindowTypeCode (h) == WT_BUTTON && GetControlID (h) == 1 
	&& GetControlID (GetNextWindow (h)) == 5


EndFunction

Int Function IsEditionSaisie (handle hwnd)
return GetWindowTypeCode (hwnd) == WT_EDIT
	&& GetControlID (hwnd) == 1
	&& GetWindowSubtypeCode (GetNextWindow (hwnd)) == WT_READONLYEDIT
EndFunction


Int Function IsEditionConnectSearch (handle hwnd)
return GetWindowSubtypeCode (hwnd) == WT_EDIt
	&& GetControlID (hwnd) == 2
	&& GetWindowClass (GetPriorWindow (hwnd)) == "ThunderRt6timer"
EndFunction


String Function GetPromptListeUser (handle hwnd)
; retourne le nom de l'onglet associ  la liste des users
if GetWindowTypeCode (GetNextWindow (hwnd)) == WT_TABCONTROL then
	; l'onglet est une fentre plus loin
	return GetWindowName (GetNextWindow (hwnd))
elif GetWindowTypeCode (GetNextWindow (GetNextWindow (hwnd))) == WT_TABCONTROL then
	; l'onglet est deux fentres plus loin
	return GetWindowName (GetNextWindow (GetNextWindow (hwnd)))
else
	; pas trouv d'onglet
	return ""
endif
EndFunction

String Function GetPromptListeTransfers (handle hwnd)
; retourne le nom de l'onglet associ  une liste de transfers
var	handle hOnglet,
	string s

let hOnglet = GetNextWindow (GetParent (hwnd))
if GetWindowTypeCode (hOnglet) == WT_TABCONTROL then
	if IsListeQueueFile (hwnd) then
		let s = "file"
	elif IsListeQueueUser (hwnd) then
		let s = "user"
	endif
	return GetWindowName (hOnglet) +  " " + s
else
	; pas trouv d'onglet
	return ""
endif
EndFunction

Void Function SayObjectTypeAndText ()
SayWindowTypeAndText (GetCurrentWindow ())
EndFunction

Void Function SayWindowTypeAndText (handle hwnd)
var 
	string prompt,
	int CID,
	handle GrandParent,
	int CIDGrandParent

let CID = GetControlID (hwnd)
let GrandParent = GetParent (GetParent (hwnd))
let CIDGrandParent = GetControlID (GrandParent)
if CIDGrandParent ==  3244 then
	if CID == 1 then
		SayString ("saisie dition")
		return
	elif CID == 2 && GetWindowSubtypeCode (hwnd) == 43 then
		SayString ("texte dition")
endif
endif
if IsListeUser (hwnd) then
	SayString (GetPromptListeUser (hwnd)) 
elif GetWindowTypeCode (hwnd) == WT_SLIDER then
	if GetFocus () == hwnd then
		RouteInvisibleToPc ()
		InvisibleCursor ()
		PriorLine ()
		SayString (GetChunk ())
		PCCursor ()
		SayString (GetWindowType (hwnd))
		SayWord ()
		return
	endif
elif IsComboSpeed (hwnd) then
	let prompt = ""
	if IsPCCursor () then
		RouteInvisibleToPc ()
		InvisibleCursor ()
		PriorWord ()
		PriorWord ()
		let prompt = GetChunk ()
		PCCursor ()
	endif
	SayString (prompt + " " + GetWindowType (GetParent (hwnd)))
	SayString (GetWindowText (hwnd, FALSE))
	return
elif IsListeTransfers (hwnd) then
	SayString (GetPromptListeTransfers (hwnd))
elif hwnd == GetAppMainWindow (GetCurrentWindow ()) then
	return
endif
SayWindowTypeAndText (hwnd)
EndFunction

handle Function GetRealWindow (handle hwnd)
if GetWindowTypeCode (hwnd) == WT_LISTVIEW then
	return GetRealWindow (GetParent (hwnd))
else
	return GetRealWindow (hwnd)
endif
EndFunction

Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
	handle RealWindow,
	string RealWindowName,
	handle AppWindow

if NoFocusEvent then
	return
endif
; dplacement automatique du focus sur la liste des users
if GetControlID (FocusWindow) == 3244 
	|| (GetControlID (FocusWindow) == 1 && GetControlID (GetParent (GetParent (FocusWindow))) == 5) 
	|| (GetControlID (FocusWindow) == 0 && GetControlID (GetParent (FocusWindow)) == 5) then
	FocusListeUser ()	
	return
endif
if IsJavaWindow(FocusWindow) then
	switchToScriptFile ("java", "default")
endif
let RealWindow = GetRealWindow (FocusWindow)
let RealWindowName = GetWindowName (RealWindow)
let AppWindow = GetAppMainWindow (FocusWindow)
if (GlobalPrevApp != AppWindow && AppWindow != FocusWindow) then
  ; we've switched to a different app main window,
  ; and it does not have the focus, so announce it
  SayWindowTypeAndText (AppWindow)
endif
If ((GlobalPrevRealName != RealWindowName) ; name has changed
	|| (GlobalPrevReal != RealWindow)) then ; or handle has changed, then
	If ((RealWindow != AppWindow) && (RealWindow != FocusWindow)) then
		if IsEditionSaisie (FocusWindow) 
			&& GlobalPrevReal != RealWindow then 
			SetFocus (GetNextWindow (FocusWindow))
			return
		elif IsEditionConnectSearch (FocusWindow) then
			{Tab}
			return
		endif
		SayWindowTypeAndText (RealWindow)
	endif
EndIf
let GlobalFocusWindow = FocusWindow
if (GlobalPrevFocus != focusWindow) then
  SayFocusedWindow () ; will use global variable GlobalFocusWindow
else
  SayFocusedObject ()
EndIf
;above perform will return here to finish this routine
;now set all the global variables for next time.
let GlobalPrevReal = RealWindow
let GlobalPrevRealName = RealWindowName
let GlobalPrevApp = AppWindow
let GlobalPrevFocus = FocusWindow
EndFunction

Void Function NewTextEvent (handle hwnd, string buffer, int nAttributes, int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)
; lecture de la ligne complte dans une liste
if GetWindowTypeCode (hwnd) == WT_LISTVIEW 
	&& GetFocus () == hwnd 
	&& nAttributes  & ATTRIB_HIGHLIGHT then
	SaveCursor ()
	InvisibleCursor ()
	RouteInvisibleToPc ()
	; on vite la rptition  de la ligne
	if LitLigneListe then
		SetRestriction (RestrictWindow)
		SayLine ()
		SetRestriction (RestrictAppWindow)
		let LitLigneListe = FALSE
	endif
	RestoreCursor ()
	return
endif
NewTextEvent (hwnd, buffer, nAttributes, nTextColor, nBackgroundColor, nEcho, sFrameName)
EndFunction

Script ToucheTab ()
var	handle hwnd

let hwnd = GetFocus ()
if ISOngletUsers (hwnd) then
	FocusListeUser ()
elif IsListeUser (hwnd) then
	FocusEditionSearch ()
elif IsEditionSearch (hwnd) then
	FocusOngletTransfers ()
elif IsOngletTransfers (hwnd) then
	FocusListeTransfers ()
elif IsListeTransfers (hwnd) then
	if IsListeQueueUser (hwnd) then
		SetFocus (GetNextWindow (hwnd))
	else
		FocusOngletUsers ()
	endif
else
	{Tab}
endif
EndScript

Script ToucheShiftTab ()
var	handle hwnd

let hwnd = GetFocus ()
if IsListeUser (hwnd) then
	FocusOngletUsers ()
elif IsEditionSearch (hwnd) then
	FocusListeUser ()
elif IsOngletTransfers (hwnd) then
	FocusEditionSearch ()
elif IsListeTransfers (hwnd) then
	if IsListeQueueFile (hwnd) then
		SetFocus (GetPriorWindow (hwnd))
	else
		FocusOngletTransfers ()
	endif
elif ISOngletUsers (hwnd) then
	FocusListeTransfers ()
else
	{Shift+Tab}
endif
EndScript

Void Function FocusOngletUsers ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 10)
if hwnd != 0 then
	let hwnd = GetFirstChild (hwnd)
	let hwnd = GetNextWindow (GetNextWindow (hwnd))
	if GetWindowTypeCode (hwnd) == WT_TABCONTROL 
		&& IsWindowVisible (hwnd) then
		SetFocus (hwnd)
	endif
endif
EndFunction

Void Function FocusListeUser ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 10)
let hwnd = GetFirstChild (hwnd)
if GetWindowTypeCode (hwnd) == WT_LISTVIEW  then
	if IsWindowVisible (hwnd) then
		SetFocus (hwnd)
	elif IsWindowVisible (GetNextWindow (hwnd)) != 0 then
		SetFocus (GetNextWindow (hwnd))
	endif
endif
EndFunction

Void Function FocusEditionSearch ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 5)
let hwnd = FindDescendantWindow (hwnd, 6)
if hwnd != 0  then
	if GetWindowTypeCode (hwnd) == WT_EDIT then
		SetFocus (hwnd)
	else
		SayString ("pas une edition")
	endif
else
	SayString ("non trouv")
endif
EndFunction

Void Function FocusOngletTransfers ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 9)
if hwnd != 0 then
	let hwnd = GetNextWindow (hwnd)
	if GetWindowTypeCode (hwnd) == WT_TABCONTROL && IsWindowVisible (hwnd) then
		SetFocus (hwnd)
	endif
endif
EndFunction

Void Function FocusListeTransfers ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 9)
if hwnd != 0 then
	let hwnd = GetFirstChild (hwnd)
	while hwnd != 0 && not IsWindowVisible (hwnd)
		let hwnd = GetNextWindow (hwnd)
	endwhile
	if hwnd != 0 then
		SetFocus (hwnd)
	endif
endif
EndFunction

Void Function FocusListeHub ()
var handle hwnd

let hwnd = GetRealWindow (hwnd)
let hwnd = FindDescendantWindow (hwnd, 6)
let hwnd = GetNextWindow (hwnd)
if GetWindowTypeCode (hwnd) == WT_LISTVIEW && IsWindowVisible (hwnd) then
	SetFocus (hwnd)
endif
EndFunction

Script GoToListeUsers ()
FocusListeUser ()
EndScript

Script GotoListeSharing ()
let NoFocusEvent = TRUE
FocusOngletTransfers ()
Pause ()
{Home}
Pause ()
let NoFocusEvent = FALSE
FocusListeTransfers ()
EndScript

Script GotoListeDownload ()
let NoFocusEvent = TRUE
FocusOngletTransfers ()
Pause ()
{Home}
{RightArrow}
Pause ()
let NoFocusEvent = FALSE
FocusListeTransfers ()
EndScript

Script GotoListeQueue ()
let NoFocusEvent = TRUE
FocusOngletTransfers ()
Pause ()
{Home}
{RightArrow}
{RightArrow}
Pause ()
let NoFocusEvent = FALSE
FocusListeTransfers ()
EndScript

Script GotoListeHistory ()
let NoFocusEvent = TRUE
FocusOngletTransfers ()
Pause ()
{Home}
{RightArrow}
{RightArrow}
{RightArrow}
Pause ()
let NoFocusEvent = FALSE
FocusListeTransfers ()
EndScript

Script GotoEditionSearch ()
FocusEditionSearch ()
EndScript

Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
var	handle hwnd

let hwnd = GetFocus ()
let LitLigneListe = TRUE
if StringLength (StrKeyName) == 1 
	&& GetWindowSubtypeCode (hwnd) == 43 then
	; saisie de caractre dans une zone d'dition en lecture seule
	Beep ()
	SayString (MSG_TEXT_READ_ONLY)
endif
if NKey == 57 then
	if GetWindowTypeCode (hwnd) == WT_BUTTON 
		&& GetWindowClass (hwnd) == "ThunderRT6PictureBoxDC" then
		RouteJAWSToPc ()
		LeftMouseButton ()
		if IsDialogueConnect (hwnd) then
			Pause ()
			FocusListeHub ()
		endif
	endif
endif
if NKey == 93 then
	PerformScript MenuContextuel()
endif
KeyPressedEvent (NKey, StrKeyName, NIsBrailleKey, NIsScriptKey)
EndFunction


Script MenuContextuel ()
RouteJAWSToPc ()
RightMouseButton ()
if IsListeQueueUser (GetFocus ()) then
	RightMouseButton ()
endif
EndScript

Script ToucheEnter ()
var	handle hwnd

let hwnd = GetFocus ()
if GetWindowTypeCode (hwnd) == WT_BUTTON then
	RouteJAWSToPc ()
	LeftMouseButton ()
	if IsDialogueConnect (hwnd) then
		Pause ()
		FocusListeHub ()
	endif
elif IsListeUser (hwnd) 
	|| IsListeHub (hwnd) then
	RouteJAWSToPc ()
	LeftMouseButton ()
	LeftMouseButton ()
else
	{Enter}
endif
EndScript

Script essai ()

EndScript

Script ActiveDialogueConnect ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 5)
let hwnd = GetNextWindow (GetFirstChild (hwnd))
if hwnd != 0 && IsWindowVisible (hwnd) then
	JAWSCursor ()
	MoveToWindow (hwnd)
	NextCharacter ()
	if GetCurrentWindow () == hwnd then
LeftMouseButton ()
	else
		SayString (MSG_CONNECT_NOT_FOUND)
	endif
	PCCursor ()
endif
EndScript

Script ActiveDialogueSetting ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 5)
let hwnd = GetNextWindow (GetFirstChild (hwnd))
if hwnd != 0 && IsWindowVisible (hwnd) then
	JAWSCursor ()
	MoveToWindow (hwnd)
	NextWord ()
	NextWord ()
	NextWord ()
	LeftMouseButton ()
	PCCursor ()
endif
EndScript

Script ActiveHelp ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 5)
let hwnd = GetNextWindow (GetFirstChild (hwnd))
if hwnd != 0 && IsWindowVisible (hwnd) then
	JAWSCursor ()
	MoveToWindow (hwnd)
	NextWord ()
	NextWord ()
	NextWord ()
	NextWord ()
	LeftMouseButton ()
	PCCursor ()
endif
EndScript

Script ActiveDialogueChat ()
chat ()
EndScript

Void Function SayLine ()
if IsComboSpeed (GetFocus ()) then
	SayString (GetWindowText (GetFocus (), FALSE))
else
	SayLine ()
endif
EndFunction

;modifier le le vendredi 29 mars 2002, da.mota.david@wanadoo.fr

Script status ()
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (GetRealWindow (GetCurrentWindow ()), "b users:", S_TOP, S_UNRESTRICTED) then
NextCharacter ()
If GetWord () == " users: " Then
NextCharacter ()
NextCharacter ()
NextCharacter ()
NextCharacter ()
NextCharacter ()
NextCharacter ()
NextCharacter ()
NextCharacter ()
SayFromCursor ()
EndIf
SayFromCursor ()
EndIf
PCCursor ()
EndScript

Script hamer ()
JAWSCursor ()
RouteJAWSToPc ()
Pause ()
If FindString (GetRealWindow (GetCurrentWindow ()), "Hammer", S_TOP, S_UNRESTRICTED) then
	NextCharacter ()
LeftMouseButton ()
SayWord ()
ElIf FindString (GetRealWindow (GetCurrentWindow ()), "Hammer", S_BOTTOM, S_UNRESTRICTED) then
	NextCharacter ()
LeftMouseButton ()
SayWord ()
Else chat ()
Pause ()
Pause ()
If FindString (GetRealWindow (GetCurrentWindow ()), "Hammer", S_TOP, S_UNRESTRICTED) then
Pause ()
Pause ()
	NextCharacter ()
LeftMouseButton ()
Pause ()
chat ()
{ctrl+f4}
SayWord ()
ElIf FindString (GetRealWindow (GetCurrentWindow ()), "Hammer", S_BOTTOM, S_UNRESTRICTED) then
Pause ()
Pause ()
	NextCharacter ()
LeftMouseButton ()
Pause ()
chat ()
{ctrl+f4}
SayWord ()
Else SayString ("Je ne trouve pas le bouton hammer")
EndIf
EndIf
PCCursor ()
EndScript

Function chat ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 11)
let hwnd = GetFirstChild (GetNextWindow (hwnd))
if hwnd != 0 && IsWindowVisible (hwnd) then
	JAWSCursor ()
	MoveToWindow (hwnd)
	NextCharacter ()
	LeftMouseButton ()
	PCCursor ()
endif
EndFunction

Script MinimiseWindow ()
MoveToWindow (GetParent (GetCurrentWindow ()))
RestrictCursor (ON)
JAWSEnd ()
PriorWord ()
PriorWord ()
If GetWord () == "minimize" then
LeftMouseButton ()
ElIf FindGraphic (GetRealWindow (GetCurrentWindow ()), "minimize symbol", S_TOP, S_RESTRICTED) then
LeftMouseButton ()
ElIf FindGraphic (GetRealWindow (GetCurrentWindow ()), "minimize symbol", S_BOTTOM, S_RESTRICTED) then
LeftMouseButton ()
Else SayString ("pas possible")
EndIf
RestrictCursor (Off)
SayString ("minimiz")
PCCursor ()
EndScript

Script MaximiseWindow ()
MoveToWindow (GetParent (GetCurrentWindow ()))
RestrictCursor (ON)
JAWSEnd ()
PriorWord ()
If GetWord () == "maximize" then
LeftMouseButton ()
ElIf FindGraphic (GetRealWindow (GetCurrentWindow ()), "maximize symbol", S_TOP, S_RESTRICTED) then
LeftMouseButton ()
ElIf FindGraphic (GetRealWindow (GetCurrentWindow ()), "maximize symbol", S_BOTTOM, S_RESTRICTED) then
LeftMouseButton ()
Else SayString ("pas possible")
EndIf
RestrictCursor (Off)
SayString ("agrandit")
PCCursor ()
EndScript

Function ChatPosition ()
var handle hwnd

let hwnd = GetTopLevelWindow (GetFocus ())
let hwnd = FindDescendantWindow (hwnd, 11)
let hwnd = GetFirstChild (GetNextWindow (hwnd))
if hwnd != 0 && IsWindowVisible (hwnd) then
	JAWSCursor ()
	MoveToWindow (hwnd)
endif
EndFunction

Script ListeFenetres ()
ChatPosition ()
Var String liste,
int index

While GetWindowClass (GetCurrentWindow ()) == "msvb_lib_toolbar"
Let liste = liste + "|" + GetChunk ()
NextChunk ()
EndWhile
let index = DlgSelectItemInList (liste, "Listes des fentres", False)
ChatPosition ()
While index >1 
NextChunk ()
Let index = index - 1
EndWhile
Pause ()
NextCharacter ()
LeftMouseButton ()
PCCursor ()

EndScript

Script ActiveUserListe ()
JAWSCursor ()
RouteJAWSToPc ()
If FindString (GetRealWindow (GetCurrentWindow ()), "Users", S_TOP, S_UNRESTRICTED) then
NextCharacter ()
LeftMouseButton ()
ElIf FindString (GetRealWindow (GetCurrentWindow ()), "Users", S_BOTTOM, S_UNRESTRICTED) then
NextCharacter ()

LeftMouseButton ()
Else SayString (MSG_CONNECT_NOT_FOUND)
EndIf
SayString ("Users")
PCCursor ()
EndScript

Script ActiveTransfertListe ()
JAWSCursor ()
RouteJAWSToPc ()
If FindString (GetRealWindow (GetCurrentWindow ()), "Transfers", S_TOP, S_UNRESTRICTED) then
NextCharacter ()
LeftMouseButton ()
ElIf FindString (GetRealWindow (GetCurrentWindow ()), "Transfers", S_BOTTOM, S_UNRESTRICTED) then
NextCharacter ()
LeftMouseButton ()
Else SayString (MSG_CONNECT_NOT_FOUND)
EndIf
SayString ("Transfers")
PCCursor ()
EndScript
